/*
    fib_add.c
    Jos bolji "ispravak" programa za Fibonaccijeve brojeve.
    Rekurzije nema jer nije potrebna, kao ni polje.
*/

#include <stdio.h>

int broj_poziva;

int fibo ( int n )
{
    int i, f_0, f_1, f_2;

    broj_poziva++;

    if (n==0) return 0;
    if (n==1) return 1;

    f_1 = 0;
    f_0 = 1;
    for (i = 2; i <= n; ++i) {
        f_2 = f_1;
        f_1 = f_0;
        f_0 = f_1 + f_2;
    }

    return f_0;
}


int main ()
{
    int broj, i;

    printf("Unesite prirodni broj: ");
    scanf("%d", &broj);
    printf("\n");

    broj_poziva=0;
    for (i = 0; i <= broj; ++i)
        printf (" F(%2d) = %11d  (broj poziva = %2d)\n",
                i, fibo (i), broj_poziva);

    return 0;
}
