#include <stdio.h>

  /* Sortiranje QuickSort algoritmom.
     Varijanta iz Wirtha (A+DS=P):
     x[srednji] je kljucni element i
     dovodimo ga na pravo mjesto u polju. */

void swap(int *a, int *b)
{
    int temp;

    temp = *a;
    *a = *b;
    *b = temp;

    return;
}

void quick_sort(int x[], int l, int d)
{
    int i, j, s;

    s = (l + d) / 2;
    i = l;
    j = d;

        /* Prolaz mora i za i == j */
    do {
        while (x[i] < x[s]) ++i;
        while (x[j] > x[s]) --j;
        if (i <= j) {
                /* Zamjena ne treba za i == j */
            swap(&x[i], &x[j]);
            ++i;
            --j;
        }
    }
    while (i <= j);
    if (l < j) quick_sort(x, l, j);
    if (i < d) quick_sort(x, i, d);

    return;
}

int main(void) {
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    quick_sort(x, 0, n - 1);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }
    return 0;
}
