#include <stdio.h>
#include <string.h>
#include <ctype.h>

/*
int samoglasnik(int c);
int samogl_2(char *s, char *p_prvi);
char *samogl_4(char *s, int *p_broj);
*/

int samoglasnik(int c)
{
      /* Pretvaramo c u malo slovo
         da skratimo ispitivanje */

    c = tolower(c);
    return (c == 'a' || c == 'e' || c == 'i' ||
            c == 'o' || c == 'u');
}

int samogl_2(char *s, char *p_prvi)
{
    int broj = 0, i;

    for (i = 0; s[i] != '\0'; ++i)
        if (samoglasnik(s[i]))
            if (++broj == 1) *p_prvi = s[i];

    return broj;
}

char *samogl_4(char *s, int *p_broj)
{
    int broj = 0, i;
    char *p_prvi = NULL;

    for (i = 0; s[i] != '\0'; ++i)
        if (samoglasnik(s[i]))
            if (++broj == 1) p_prvi = s + i;

    *p_broj = broj;
    return p_prvi;
}

int main(void) {
    char kolegij[] = "Programiranje (C)";
    char prvi = ' ', *p_prvi = &prvi;
    int broj = -1, *p_broj = &broj;

    printf(" Pocetni string:\n");
    puts(kolegij);

    broj = samogl_2(kolegij, p_prvi);
    printf(" samogl_2: broj = %d, prvi = %c:\n",
           broj, *p_prvi);

    p_prvi = samogl_4(kolegij, p_broj);
    printf(" samogl_4: broj = %d, prvi = %c:\n",
           *p_broj, *p_prvi);

    return 0;
}
