#include <stdio.h>

  /* Postavljanje eof i error flagova
     za testiranje feof i ferror funkcija. */
  /* VSego, mail, v. 00_12_s2.txt. */

int main(void) {
    FILE *fp = fopen("ferr.dat", "r");

    printf("Test 0: feof = %d, ferror = %d\n", feof(fp), ferror(fp));

    fp->_flag = 16;  // feof
    printf("Test 1: feof = %d, ferror = %d\n", feof(fp), ferror(fp));

    fp->_flag = 32;  // ferror
    printf("Test 2: feof = %d, ferror = %d\n", feof(fp), ferror(fp));

    fp->_flag = 16+32;  // feof + ferror
    printf("Test 3: feof = %d, ferror = %d\n", feof(fp), ferror(fp));

    do {
        printf("%c", fgetc(fp));
    } while (!feof(fp));
    printf("\nTest 4: feof = %d, ferror = %d\n", feof(fp), ferror(fp));

    fseek(fp, 1L, SEEK_SET);
    printf("Test 5: feof = %d, ferror = %d\n", feof(fp), ferror(fp));

    fseek(fp, 100000000L, SEEK_SET);
    printf("Test 6: feof = %d, ferror = %d\n", feof(fp), ferror(fp));

    fclose(fp);
    return 0;
}
