#include <stdio.h>

  /* Fibonaccijevi brojevi - rekurzivno.

     Koristi globalni (static) brojac poziva
     koji se automatski inicijalizira na 0
     prilikom deklaracije.
  */

long int broj_poziva;


    /* Rekurzivni Fibonacci. */

long int fib(int n)
{
    ++broj_poziva;

    if (n == 0) return 0;
    if (n == 1) return 1;

    return fib(n - 1) + fib(n - 2);
}


int main(void)
{
    int n;

    printf(" Unesite prirodni broj n: ");
    scanf("%d", &n);
    printf("\n");

    broj_poziva = 0;

    printf(" Fibonaccijev broj  F(%d) = %ld\n", n, fib(n));
    printf(" Broj poziva funkcije fib = %ld\n", broj_poziva);

    return 0;
}
