#include <stdio.h>

void funkcija(int M[4][3])
{
    printf("%3u, %p\n", sizeof(M), M);
    printf("%3u, %p\n", sizeof(M[0]), M[0]);
    printf("%3u, %p\n", sizeof(M[0][0]), &M[0][0]);

    printf("%3u, %p, %d\n", sizeof(M[1]), M[1], M[1][0]);
    printf("%3u, %p, %d\n", sizeof(M[2]), M[2], M[2][0]);

      /* Element M[2][3] ima pogresan drugi indeks - izvan granica.
         Prevoditelj to moze provjeriti prema deklaraciji argumenta
         i uredno javlja warning. */

    printf("%3u, %p, %d\n", sizeof(M[2][3]), &M[2][3], M[2][3]);

      /* Element M[4][2] ima pogresan prvi indeks - izvan granica.
         Prevoditelj ignorira prvu dimenziju u deklaraciji argumenta
         i ne javlja nista. */

    printf("%3u, %p, %d\n", sizeof(M[4][2]), &M[4][2], M[4][2]);

    return;
}

int main(void)
{
    int M[4][3] = {
      {1, 2, 3}, {4, 5, 6}, {7, 8, 9}, {10, 11, 12}
    };

    printf("Glavni program:\n");

    printf("%3u, %p\n", sizeof(M), M);
    printf("%3u, %p\n", sizeof(M[0]), M[0]);
    printf("%3u, %p\n", sizeof(M[0][0]), &M[0][0]);

    printf("%3u, %p, %d\n", sizeof(M[1]), M[1], M[1][0]);
    printf("%3u, %p, %d\n", sizeof(M[2]), M[2], M[2][0]);

      /* Element M[2][3] ima pogresan drugi indeks - izvan granica.
         Prevoditelj to moze provjeriti prema deklaraciji argumenta
         i uredno javlja warning. */

    printf("%3u, %p, %d\n", sizeof(M[2][3]), &M[2][3], M[2][3]);

      /* Element M[4][2] ima pogresan prvi indeks - izvan granica.
         Prevoditelj ovdje to moze provjeriti prema deklaraciji matrice
         (to je i definicija matrice) i uredno javlja warning. */

    printf("%3u, %p, %d\n", sizeof(M[4][2]), &M[4][2], M[4][2]);

    printf("Funkcija(M):\n");
    funkcija(M);
/*
    printf("Funkcija(M[1]):\n");
    funkcija(M[1]);
*/
    return 0;
}
