#include <stdio.h>
#include <math.h>
#include "compl.h"

int main(void)
{
    complex z1 = { 1.0, 2.0 }, z2 = { 1.0, 1.0 };

    printf(" z1 = ");
    cprint(z1);
    printf(" z2 = ");
    cprint(z2);

    printf(" cabs(z1) = %g\n", zabs(z1));
    printf(" cabs(z2) = %g\n", zabs(z2));

    printf(" conjug(z1) = ");
    cprint(conjug(z1));
    printf(" conjug(z2) = ");
    cprint(conjug(z2));

    printf(" z1 + z2 = ");
    cprint(cadd(z1, z2));
    printf(" z1 - z2 = ");
    cprint(csub(z1, z2));
    printf(" z1 * z2 = ");
    cprint(cmul(z1, z2));
    printf(" z1 / z2 = ");
    cprint(cdiv(z1, z2));

    return 0;
}
