#include <stdio.h>
#include <math.h>
#include "tocka.h"

double udaljenost(tocka A, tocka B)
{
    double dx = A.x - B.x;
    double dy = A.y - B.y;
    return sqrt(dx * dx + dy * dy);
}

double udaljenost_od_ishodista(tocka A)
{
    tocka O = { 0.0, 0.0 };
    return udaljenost(A, O);
}

tocka centralno_simetricna(tocka A)
{
    A.x = -A.x;
    A.y = -A.y;
    return A;
}

void translatiraj_tocku(tocka *A, tocka B)
{
    A->x = A->x + B.x;
    A->y = A->y + B.y;
}

void ispisi_tocku(char *ime_tocke, tocka A)
{
    printf("%s(%g, %g)\n", ime_tocke, A.x, A.y);
}
